VTK: vtkPiecewisePointHandleItem Class Reference

| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkPiecewisePointHandleItem Class Reference

a vtkContextItem that draws handles around a point of a piecewise function More...

`#include <vtkPiecewisePointHandleItem.h>`

Inheritance diagram for vtkPiecewisePointHandleItem:
[legend]
Collaboration diagram for vtkPiecewisePointHandleItem:
[legend]

## Public Types
typedef vtkContextItem | Superclass
Public Types inherited from vtkContextItem
typedef vtkAbstractContextItem | Superclass
Public Types inherited from vtkAbstractContextItem
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkPiecewisePointHandleItem * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetParent (vtkAbstractContextItem *parent) override
| Set the parent item, which should be a vtkControlPointItem. More...
bool | Paint (vtkContext2D *painter) override
| Paint event for the item. More...
virtual void | SetCurrentPointIndex (vtkIdType)
| The current point id in the piecewise function being handled. More...
virtual vtkIdType | GetCurrentPointIndex ()
virtual void | SetPiecewiseFunction (vtkPiecewiseFunction *piecewiseFunc)
| Set the PieceWiseFunction the handles will manipulate. More...
vtkWeakPointer< vtkPiecewiseFunction > | GetPiecewiseFunction ()
int | IsOverHandle (float *pos)
| Returns the index of the handle if pos is over any of the handles, otherwise return -1;. More...
bool | Hit (const vtkContextMouseEvent &mouse) override
| Returns true if the supplied x, y coordinate is inside the item. More...
bool | MouseMoveEvent (const vtkContextMouseEvent &mouse) override
| Mouse move event. More...
bool | MouseButtonPressEvent (const vtkContextMouseEvent &mouse) override
| Mouse button down event. More...
bool | MouseButtonReleaseEvent (const vtkContextMouseEvent &mouse) override
| Mouse button release event. More...
Public Member Functions inherited from vtkContextItem
vtkContextItem * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual double | GetOpacity ()
| Get the opacity of the item. More...
virtual void | SetOpacity (double)
| Set the opacity of the item. More...
Public Member Functions inherited from vtkAbstractContextItem
vtkAbstractContextItem * | NewInstance () const
virtual void | Update ()
| Perform any updates to the item that may be necessary before rendering. More...
virtual bool | PaintChildren (vtkContext2D *painter)
| Paint the children of the item, should be called whenever the children need to be rendered. More...
virtual void | ReleaseGraphicsResources ()
| Release graphics resources hold by the item. More...
vtkIdType | AddItem (vtkAbstractContextItem *item)
| Add child items to this item. More...
bool | RemoveItem (vtkAbstractContextItem *item)
| Remove child item from this item. More...
bool | RemoveItem (vtkIdType index)
| Remove child item from this item. More...
vtkAbstractContextItem * | GetItem (vtkIdType index)
| Get the item at the specified index. More...
vtkIdType | GetItemIndex (vtkAbstractContextItem *item)
| Get the index of the specified item in itemIndex. More...
vtkIdType | GetNumberOfItems ()
| Get the number of child items. More...
void | ClearItems ()
| Remove all child items from this item. More...
vtkIdType | Raise (vtkIdType index)
| Raises the child to the top of the item's stack. More...
virtual vtkIdType | StackAbove (vtkIdType index, vtkIdType under)
| Raises the child above the under sibling. More...
vtkIdType | Lower (vtkIdType index)
| Lowers the child to the bottom of the item's stack. More...
virtual vtkIdType | StackUnder (vtkIdType child, vtkIdType above)
| Lowers the child under the above sibling. More...
virtual vtkAbstractContextItem * | GetPickedItem (const vtkContextMouseEvent &mouse)
| Return the item under the mouse. More...
virtual bool | MouseEnterEvent (const vtkContextMouseEvent &mouse)
| Mouse enter event. More...
virtual bool | MouseLeaveEvent (const vtkContextMouseEvent &mouse)
| Mouse leave event. More...
virtual bool | MouseDoubleClickEvent (const vtkContextMouseEvent &mouse)
| Mouse button double click event. More...
virtual bool | MouseWheelEvent (const vtkContextMouseEvent &mouse, int delta)
| Mouse wheel event, positive delta indicates forward movement of the wheel. More...
virtual bool | KeyPressEvent (const vtkContextKeyEvent &key)
| Key press event. More...
virtual bool | KeyReleaseEvent (const vtkContextKeyEvent &key)
| Key release event. More...
virtual void | SetScene (vtkContextScene *scene)
| Set the vtkContextScene for the item, always set for an item in a scene. More...
vtkContextScene * | GetScene ()
| Get the vtkContextScene for the item, always set for an item in a scene. More...
vtkAbstractContextItem * | GetParent ()
| Get the parent item. More...
virtual vtkVector2f | MapToParent (const vtkVector2f &point)
| Maps the point to the parent coordinate system. More...
virtual vtkVector2f | MapFromParent (const vtkVector2f &point)
| Maps the point from the parent coordinate system. More...
virtual vtkVector2f | MapToScene (const vtkVector2f &point)
| Maps the point to the scene coordinate system. More...
virtual vtkVector2f | MapFromScene (const vtkVector2f &point)
| Maps the point from the scene coordinate system. More...
virtual bool | GetVisible ()
| Get the visibility of the item (should it be drawn). More...
virtual void | SetVisible (bool)
| Set the visibility of the item (should it be drawn). More...
virtual bool | GetInteractive ()
| Get if the item is interactive (should respond to mouse events). More...
virtual void | SetInteractive (bool)
| Set if the item is interactive (should respond to mouse events). More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPiecewisePointHandleItem * | SafeDownCast (vtkObjectBase *o)
static vtkPiecewisePointHandleItem * | New ()
static void | CallRedraw (vtkObject *sender, unsigned long event, void *receiver, void *params)
Static Public Member Functions inherited from vtkContextItem
static vtkTypeBool | IsTypeOf (const char *type)
static vtkContextItem * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAbstractContextItem
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractContextItem * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkPiecewisePointHandleItem ()
| ~vtkPiecewisePointHandleItem () override
virtual void | Redraw ()
| Redraw all the handles. More...
Protected Member Functions inherited from vtkContextItem
| vtkContextItem ()
| ~vtkContextItem () override
Protected Member Functions inherited from vtkAbstractContextItem
| vtkAbstractContextItem ()
| ~vtkAbstractContextItem () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | MouseOverHandleIndex
vtkIdType | CurrentPointIndex
float | HandleRadius
vtkWeakPointer< vtkPiecewiseFunction > | PiecewiseFunction
vtkCallbackCommand * | Callback
Protected Attributes inherited from vtkContextItem
double | Opacity
Protected Attributes inherited from vtkAbstractContextItem
vtkContextScene * | Scene
| Point to the scene the item is on - can be null. More...
vtkAbstractContextItem * | Parent
| Point to the parent item - can be null. More...
vtkContextScenePrivate * | Children
| This structure provides a list of children, along with convenience functions to paint the children etc. More...
bool | Visible
| Store the visibility of the item (default is true). More...
bool | Interactive
| Store whether the item should respond to interactions (default is true). More...
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

a vtkContextItem that draws handles around a point of a piecewise function

This is a vtkContextItem that can be placed into a vtkContextScene. It draws handles around a given point of a piecewise function so that the curve can be adjusted using these handles.

Definition at line 39 of file vtkPiecewisePointHandleItem.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkContextItem vtkPiecewisePointHandleItem::Superclass

Definition at line 42 of file vtkPiecewisePointHandleItem.h.

## Constructor & Destructor Documentation

## ◆ vtkPiecewisePointHandleItem()

vtkPiecewisePointHandleItem::vtkPiecewisePointHandleItem | ( |  | ) |
| protected

## ◆ ~vtkPiecewisePointHandleItem()

vtkPiecewisePointHandleItem::~vtkPiecewisePointHandleItem | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkPiecewisePointHandleItem::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkPiecewisePointHandleItem::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkContextItem.

## ◆ SafeDownCast()

static vtkPiecewisePointHandleItem* vtkPiecewisePointHandleItem::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkPiecewisePointHandleItem::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkContextItem.

## ◆ NewInstance()

vtkPiecewisePointHandleItem* vtkPiecewisePointHandleItem::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkPiecewisePointHandleItem::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObjectBase.

## ◆ New()

static vtkPiecewisePointHandleItem* vtkPiecewisePointHandleItem::New | ( |  | ) |
| static

## ◆ CallRedraw()

static void vtkPiecewisePointHandleItem::CallRedraw | ( | vtkObject * | sender,
|  | unsigned long | event,
|  | void * | receiver,
|  | void * | params
| ) |  |
| static

## ◆ SetParent()

void vtkPiecewisePointHandleItem::SetParent | ( | vtkAbstractContextItem * | parent | ) |
| overridevirtual

Set the parent item, which should be a vtkControlPointItem.

Reimplemented from vtkAbstractContextItem.

## ◆ Paint()

bool vtkPiecewisePointHandleItem::Paint | ( | vtkContext2D * | painter | ) |
| overridevirtual

Paint event for the item.

Reimplemented from vtkAbstractContextItem.

## ◆ SetCurrentPointIndex()

virtual void vtkPiecewisePointHandleItem::SetCurrentPointIndex | ( | vtkIdType |  | ) |
| virtual

The current point id in the piecewise function being handled.

## ◆ GetCurrentPointIndex()

virtual vtkIdType vtkPiecewisePointHandleItem::GetCurrentPointIndex | ( |  | ) |
| virtual

## ◆ SetPiecewiseFunction()

virtual void vtkPiecewisePointHandleItem::SetPiecewiseFunction | ( | vtkPiecewiseFunction * | piecewiseFunc | ) |
| virtual

Set the PieceWiseFunction the handles will manipulate.

## ◆ GetPiecewiseFunction()

vtkWeakPointer<vtkPiecewiseFunction> vtkPiecewisePointHandleItem::GetPiecewiseFunction | ( |  | ) |

## ◆ IsOverHandle()

int vtkPiecewisePointHandleItem::IsOverHandle | ( | float * | pos | ) |

Returns the index of the handle if pos is over any of the handles, otherwise return -1;.

## ◆ Hit()

bool vtkPiecewisePointHandleItem::Hit | ( | const vtkContextMouseEvent & | mouse | ) |
| overridevirtual

Returns true if the supplied x, y coordinate is inside the item.

Reimplemented from vtkAbstractContextItem.

## ◆ MouseMoveEvent()

bool vtkPiecewisePointHandleItem::MouseMoveEvent | ( | const vtkContextMouseEvent & | mouse | ) |
| overridevirtual

Mouse move event.

Reimplemented from vtkAbstractContextItem.

## ◆ MouseButtonPressEvent()

bool vtkPiecewisePointHandleItem::MouseButtonPressEvent | ( | const vtkContextMouseEvent & | mouse | ) |
| overridevirtual

Mouse button down event.

Reimplemented from vtkAbstractContextItem.

## ◆ MouseButtonReleaseEvent()

bool vtkPiecewisePointHandleItem::MouseButtonReleaseEvent | ( | const vtkContextMouseEvent & | mouse | ) |
| overridevirtual

Mouse button release event.

Reimplemented from vtkAbstractContextItem.

## ◆ Redraw()

virtual void vtkPiecewisePointHandleItem::Redraw | ( |  | ) |
| protectedvirtual

Redraw all the handles.

## Member Data Documentation

## ◆ MouseOverHandleIndex

int vtkPiecewisePointHandleItem::MouseOverHandleIndex
| protected

Definition at line 109 of file vtkPiecewisePointHandleItem.h.

## ◆ CurrentPointIndex

vtkIdType vtkPiecewisePointHandleItem::CurrentPointIndex
| protected

Definition at line 110 of file vtkPiecewisePointHandleItem.h.

## ◆ HandleRadius

float vtkPiecewisePointHandleItem::HandleRadius
| protected

Definition at line 111 of file vtkPiecewisePointHandleItem.h.

## ◆ PiecewiseFunction

vtkWeakPointer<vtkPiecewiseFunction> vtkPiecewisePointHandleItem::PiecewiseFunction
| protected

Definition at line 113 of file vtkPiecewisePointHandleItem.h.

## ◆ Callback

vtkCallbackCommand* vtkPiecewisePointHandleItem::Callback
| protected

Definition at line 114 of file vtkPiecewisePointHandleItem.h.

The documentation for this class was generated from the following file:

- Charts/Core/vtkPiecewisePointHandleItem.h